All Vulnerability Reports

CVE-2021-22097: Spring-AMQP Remote Denial of Service - Deserialization of a Maliciously Constructed java.util.Dictionary Object


Severity

Medium

Vendor

Spring by VMware

Description

The Spring AMQP Message object, in its toString() method, will deserialize a body for a message with content type application/x-java-serialized-object. Classes in the java.lang and java.util packages are trusted.

It is possible to construct a malicious java.util.Dictionary object that can cause 100% CPU usage in the application if the toString() method is called.

This requires the attacker to have privileges to directly publish messages with such a body to the RabbitMQ server.

Affected VMware Products and Versions

Severity is medium unless otherwise noted.

  • Spring AMQP
    • 2.2.0 - 2.2.18
    • 2.3.0 - 2.3.10
Mitigation

Do not allow untrustworthy actors to publish arbitrary data to RabbitMQ. Users of affected versions should apply the following mitigation. 2.3.x users should upgrade to 2.3.11. 2.2.x users should upgrade to 2.2.19. No other steps are necessary. Releases that have fixed this issue include:

  • Spring AMQP
    • 2.3.11
    • 2.2.19
Credit

This issue was identified and responsibly reported by r00t4dm Cloud-Penetrating Arrow Lab of Meituan Corp Information Security Department.

References
History

2021-10-26: Initial vulnerability report published.